'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Sandbox = function () {
  function Sandbox() {
    var _this = this;

    _classCallCheck(this, Sandbox);

    if (typeof document !== 'undefined') {
      this.frame = document.createElement('iframe');
      this.frame.style.display = 'none';
      this.frame.addEventListener('load', function () {
        _this.frame.contentWindow.executeWindow = {};
        _this.executeWindow = _this.frame.contentWindow.executeWindow;
      });

      document.body.appendChild(this.frame);
    }
  }

  _createClass(Sandbox, [{
    key: 'execute',
    value: function execute(code, blockNumber) {
      var _this2 = this;

      var promise = Promise.resolve();
      var exec = {
        blockNumber: blockNumber
      };

      try {
        exec.result = this.frame.contentWindow.eval('with(executeWindow){' + code + '}');
      } catch (error) {
        exec.error = error;
      }

      if (exec.result && exec.result.then && typeof exec.result.then === 'function') {
        promise = exec.result.then(function (value) {
          exec.result = value;
        }).catch(function (error) {
          exec.error = error;
        });
      }

      return promise.then(function () {
        _this2.executeWindow['$' + blockNumber] = exec.error || exec.result;

        return exec;
      });
    }
  }, {
    key: 'dispose',
    value: function dispose() {
      this.frame.parentNode.removeChild(this.frame);
    }
  }]);

  return Sandbox;
}();

exports.default = Sandbox;
//# sourceMappingURL=sandbox.js.map